using Domain;
using Domain.Input;
using Presenter;
using TMPro;
using UnityEngine;
using UnityEngine.Serialization;

namespace View.UI {
	public class ExpressionInput : MonoBehaviour, IExpressionInput {
		[SerializeField] private TMP_Text text;

		private ExpressionClick _click;
		private CustomInput _customInput;

		[SerializeField] private FramedAnimator.FramedAnimator animator;

		private void Start() {
			_click = FindObjectOfType<Dependencies>().ExpressionClick;
			_customInput = FindObjectOfType<Dependencies>().CustomInput;
		}

		private void Update() {
			CheckInput();
		}

		public void UpdateView(int score, float growPercentage) {
			animator.PlayUntil(growPercentage);
			text.text = score.ToString();
		}

		private void CheckInput() {
			_customInput.UpdateInput();

			if (_customInput.AnyKeyDown())
				_click.Execute();
		}
	}
}